<?php

require_once "../vo/authentication/LoginVO.php";
require_once "../vo/authentication/UserVO.php";
require_once "../vo/authentication/DateVO.php";

class AuthenticationService
{

    //
    // Services
    //

    // Ajoute un utilisateur au fichier
    public function registerUser($userVO)
    {
        if ($this->getUser($userVO->userName) != null)
            return false;
        
        $fp = fopen("file.csv", 'a+');
        $newUser = $this->toArray($userVO);
        fputcsv($fp, $newUser);
        
        return true;
    }
   
    // Authentifie un utilisateur
    public function authenticate($loginVO)
    {        
        $user = $this->getUser($loginVO->userName);

        if ($user != null && $user->password==$loginVO->password)
            return $user;
        
        return null;
    }

    //
    // Utils
    //
    
    // Obtenir un utilisateur
    private function getUser($username)
    {
        if (($handle = fopen("file.csv", "r")) !== FALSE)
        {
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
                if (strcmp($username, $data[0]) == 0)
                    return $this->fromArray($data);
            fclose($handle);
        }
        return $null;  
    }
    
    // Convertir un tableau en UserVO
    private function fromArray($array)
    {
        $user = new UserVO();
        $user->userName = $array[0];
        $user->firstName = $array[1];
        $user->lastName = $array[2];
        $date = explode("-", $array[3]);
        $user->birthDate = new DateVO();
        $user->birthDate->year = $date[0];
        $user->birthDate->month = $date[1];
        $user->birthDate->day = $date[2];
        $user->email = $array[4];
        $user->password = $array[5];
        return $user;
    }
    
    // Convertir un UserVO en tableau
    private function toArray($user)
    {
        $array = array();
        $array[] = $user->userName;
        $array[] = $user->firstName;
        $array[] = $user->lastName;
        $array[] = $user->birthDate->year."-".$user->birthDate->month."-".$user->birthDate->day;
        $array[] = $user->email;
        $array[] = $user->password;
        return $array;
    }
}	
?>